VERSION 5.00
Begin VB.Form frmClient 
   Caption         =   "CLIENT"
   ClientHeight    =   7920
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   9000
   LinkTopic       =   "Form1"
   ScaleHeight     =   7920
   ScaleWidth      =   9000
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdFile 
      Caption         =   "Get File"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1800
      TabIndex        =   3
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox txtHex 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   7095
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   600
      Width           =   9015
   End
   Begin VB.Label lblStatus 
      BackColor       =   &H0000FF00&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Status"
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   7680
      Width           =   9015
   End
End
Attribute VB_Name = "frmClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim WithEvents HKDF As clsHKDF
Attribute HKDF.VB_VarHelpID = -1
Dim WithEvents Crypt As clsCrypt
Attribute Crypt.VB_VarHelpID = -1
Dim WithEvents mClient As SimpleSock
Attribute mClient.VB_VarHelpID = -1

Const VERSION_MAJOR As Byte = &H1
Const VERSION_MINOR As Byte = &H0
Const MT_FINISHED As Byte = &H14           '20
Const RT_ALERT As Byte = &H15              '21
Const RT_HANDSHAKE As Byte = &H16          '22
Const RT_APPLICATION_DATA As Byte = &H17   '23
Const ClientFlg As Boolean = False
Const SvrFlg As Boolean = True

Private ECC_PRIVATE_KEY_INT() As Byte
Private ECC_PUBLIC_KEY_EXT() As Byte
Private ECK1() As Byte

Const sIKM = "8bd4054fb55b9d63fdfbacf9f04b9f0d35e6d63f537563efd46272900f89492d"
Const Divider = "-------------------------------------------------" & vbCrLf

'TLS 1.3 Constants
Const sDerived = "tls13 derived"
Const c_hs_traffic = "tls13 c hs traffic"
Const s_hs_traffic = "tls13 s hs traffic"
Const hs_write_key = "tls13 key"
Const hs_write_iv = "tls13 iv"
Const hs_read_key = "tls13 key"
Const hs_read_iv = "tls13 iv"
Const tls13_finished = "tls13 finished"
Const tls13_c_ap = "tls13 c ap traffic"
Const tls13_s_ap = "tls13 s ap traffic"
Const tls13_exp_master = "tls13 exp master"
Const tls13_res_master = "tls13 res master"
Const ap_write_key = "tls13 key"
Const ap_write_iv = "tls13 iv"
Const ap_read_key = "tls13 key"
Const ap_read_iv = "tls13 iv"
Const tls13_resumption = "tls13 resumption"

'Keys
Private KeyAlg As String
Private KeySize As Long

Private bIKM() As Byte
Private bSalt() As Byte
Private bInfo() As Byte
Private bPRK() As Byte
Private mstrSecret() As Byte

'Private bReadMAC() As Byte
'Private bWriteMAC() As Byte
Private bReadKey() As Byte
Private bWriteKey() As Byte
Private bReadIV() As Byte
Private bWriteIV() As Byte
Private bReadHSKey() As Byte
Private bWriteHSKey() As Byte
Private bReadHSIV() As Byte
Private bWriteHSIV() As Byte
Private bFinished() As Byte

'Session Variables
Private SessionHash() As Byte
Private hSessionHash As Long 'Handle to SHA256 Session Hash
Private lHash As Long
Private bHashObject() As Byte 'SHA256 Session Hash Object
Private hCOPY_SHA256 As Long 'Handle to Copy of SHA256 Session Hash
Private bPubKeyBlob()       As Byte
Private bPrivKeyBlob()      As Byte
Private Layer As Long

Private Function AddRecHeader(bRecord() As Byte) As Byte()
    'Prepend record with record header
    Dim TLSHeader(4) As Byte
    Dim RecLen As Long
    RecLen = GetbSize(bRecord)
    TLSHeader(0) = Crypt.MsgType
    TLSHeader(1) = VERSION_MAJOR
    TLSHeader(2) = VERSION_MINOR
    TLSHeader(3) = Int(RecLen / 256)
    TLSHeader(4) = RecLen Mod 256
    AddRecHeader = TLSHeader
    Call AddByte(AddRecHeader, bRecord)
End Function

Private Sub DispByte(sDescr As String, bArray() As Byte, Optional ClearFlg As Boolean)
    Dim lPntr As Long
    Dim strBuff As String
    Dim iLines As Integer
    Dim M%, N%
    lPntr = GetbSize(bArray)
    If lPntr = 0 Then Exit Sub
    If lPntr Mod 16 = 0 Then
        iLines = lPntr / 16
    Else
        iLines = Int(lPntr / 16) + 1
    End If
    strBuff = String$(iLines * 50, Chr$(32))
    Mid$(strBuff, Len(strBuff) - 1, 2) = vbCrLf
    M% = 1
    For N% = 0 To UBound(bArray) Step 1
        Mid$(strBuff, M%, 3) = Right$("0" & Hex$(bArray(N%)), 2) & " "
        M% = M% + 3
        If (N% + 1) Mod 16 = 0 Then
            Mid$(strBuff, M%, 2) = vbCrLf
            M% = M% + 2
        End If
    Next N%
    If Len(sDescr) > 0 Then sDescr = sDescr & ":" & vbCrLf
    If ClearFlg Then
        txtHex.Text = sDescr & strBuff
    Else
        txtHex.Text = txtHex.Text & sDescr & strBuff
        txtHex.SelStart = Len(txtHex.Text)
    End If
End Sub

Private Function GetClientHello(bBlob() As Byte) As Byte()
    Const sClientHello = "010000c00303cb34ecb1e78163ba1c38" _
                        & "c6dacb196a6dffa21a8d9912ec18a2ef" _
                        & "6283024dece700000613011303130201" _
                        & "0000910000000b000900000673657276" _
                        & "6572ff01000100000a00140012001d00" _
                        & "17001800190100010101020103010400" _
                        & "230000003300260024001d002099381d" _
                        & "e560e4bd43d23d8e435a7dbafeb3c06e" _
                        & "51c13cae4d5413691e529aaf2c002b00" _
                        & "03020304000d0020001e040305030603" _
                        & "02030804080508060401050106010201" _
                        & "0402050206020202002d00020101001c" _
                        & "00024001"
    GetClientHello = HexToByte(sClientHello)
    'Dim bPubKey() As Byte
    'If GetbSize(bBlob) = 0 Then
    '    MsgBox "No Public ECC key provided", vbExclamation
    'End If
    'ReDim bPubKey(GetbSize(bBlob) - 9)
    'CopyMemory bPubKey(0), bBlob(8), GetbSize(bPubKey)
    'GetClientHello = bPubKey
End Function

Private Function GetKeys(Stage As Long, bIKM() As Byte, bPSK() As Byte, Optional SvrFlg As Boolean) As Boolean
    Dim bSalt() As Byte
    Dim bEarly() As Byte
    Dim bHash() As Byte
    Static bSecretHS() As Byte 'Handshake Secret
    Static bSecretMaster() As Byte 'Master Secret
    Static bMaster() As Byte 'Master key
    Dim bReadHS() As Byte 'Handshake Read Secret
    Dim bWriteHS() As Byte 'Handshake Write Secret
    Dim bReadAP() As Byte 'Application Read Secret
    Dim bWriteAP() As Byte 'Application Write Secret
    Dim bTmp() As Byte
    Select Case Stage
        Case 0 'After Hello received
            'Since there is no Pre Shared Key, the early secret uses blank values
            If GetbSize(bPSK) = 0 Then ReDim bPSK(31)
            ReDim bSalt(31)
            Call HKDF.Extract("SHA256", bSalt, bPSK)
            bEarly = HKDF.OutBuffer
            Call DispByte("Early Secret", bEarly)
            
            'Initial value is a zero length hash
            bHash = HKDF.HashData("SHA256", bHash)
            Call DispByte("Handshake Hash", bHash)
        
            'Derived secret for handshake uses the early secret, and the zero hash with context
            bInfo = HKDF.CreateInfo("tls13 derived", bHash, 32)
            Call HKDF.Expand("SHA256", bEarly, bInfo, 32)
            bTmp = HKDF.OutBuffer
            Call DispByte("tls13 derived", bTmp)
            
            'The HandShake Secret uses the derived Master Secret and the ECDHE key
            Call HKDF.Extract("SHA256", bTmp, bIKM)
            bSecretHS = HKDF.OutBuffer
            Call DispByte("HandShake Secret", bSecretHS)
            
            'Derived secret for Master uses the HandShake secret and context from derived HandShake
            Call HKDF.Expand("SHA256", bSecretHS, bInfo, 32)
            bSecretMaster = HKDF.OutBuffer
            Call DispByte("Master tls13 derived", bSecretMaster)
        
        Case 1 'After Server Hello data
            'Derived secret for Client Handshake uses Handshake secret and context with Session Hash
            bInfo = HKDF.CreateInfo("tls13 c hs traffic", SessionHash, 32)
            Call HKDF.Expand("SHA256", bSecretHS, bInfo, 32)
            bReadHS = HKDF.OutBuffer
            Call DispByte("tls13 c hs traffic", bReadHS)
            
            'Create Certificate records here
    
            'Derived secret for Server Handshake uses Handshake secret and context with Session Hash
            bInfo(9) = 115 'tls13 s hs traffic
            Call HKDF.Expand("SHA256", bSecretHS, bInfo, 32)
            bWriteHS = HKDF.OutBuffer
            Call DispByte("tls13 s hs traffic", bWriteHS)
            
            'Master key uses derived secret for Master and blank context
            ReDim bTmp(31)
            Call HKDF.Extract("SHA256", bSecretMaster, bTmp)
            bMaster = HKDF.OutBuffer
            Call DispByte("Master", bMaster)
            
            'HandShake Read Key uses Derived secret for Server Handshake and context with zero length hash
            ReDim bTmp(0)
            bInfo = HKDF.CreateInfo("tls13 key", bTmp, 16)
            Call HKDF.Expand("SHA256", bWriteHS, bInfo, 16)
            If SvrFlg Then
                bWriteHSKey = HKDF.OutBuffer
                Call DispByte("HS Write Key", bWriteHSKey)
            Else
                bReadHSKey = HKDF.OutBuffer
                Call DispByte("HS Read Key", bReadHSKey)
            End If
            
            'HandShake Read IV uses Derived secret for Server Handshake and context with zero length hash
            bInfo = HKDF.CreateInfo("tls13 iv", bTmp, 12)
            Call HKDF.Expand("SHA256", bWriteHS, bInfo, 12)
            If SvrFlg Then
                bWriteHSIV = HKDF.OutBuffer
                Call DispByte("HS Write IV", bWriteHSIV)
            Else
                bReadHSIV = HKDF.OutBuffer
                Call DispByte("HS Read IV", bReadHSIV)
            End If
        
            'HandShake Write Key uses Derived secret for Client Handshake and context with zero length hash
            bInfo = HKDF.CreateInfo("tls13 key", bTmp, 16)
            Call HKDF.Expand("SHA256", bReadHS, bInfo, 16)
            If SvrFlg Then
                bReadHSKey = HKDF.OutBuffer
                Call DispByte("HS Read Key", bReadHSKey)
            Else
                bWriteHSKey = HKDF.OutBuffer
                Call DispByte("HS Write Key", bWriteHSKey)
            End If
        
            'HandShake Write IV uses Derived secret for Client Handshake and context with zero length hash
            bInfo = HKDF.CreateInfo("tls13 iv", bTmp, 12)
            Call HKDF.Expand("SHA256", bReadHS, bInfo, 12)
             If SvrFlg Then
                bReadHSIV = HKDF.OutBuffer
                Call DispByte("HS Read IV", bReadHSIV)
            Else
                bWriteHSIV = HKDF.OutBuffer
                Call DispByte("HS Write IV", bWriteHSIV)
            End If
        
            'Finished record uses Derived secret for Client Handshake and context
            'with zero length hash
            bInfo = HKDF.CreateInfo("tls13 finished", bTmp, 32)
            Call HKDF.Expand("SHA256", bReadHS, bInfo, 32)
            bFinished = HKDF.OutBuffer
            Call DispByte("tls13 finished", bFinished)
        
        Case 2 'After Finished record
            'Final Finished record uses tls13 finished & Session Hash
            Call HKDF.Extract("SHA256", bFinished, SessionHash)
            bFinished = HKDF.OutBuffer
            Call DispByte("Finished", bFinished)
            Dim Finish() As Byte
            ReDim Finish(3)
            Finish(0) = &H14: Finish(3) = &H20
            Call AddByte(Finish, bFinished)
            Call DispByte("Finish", Finish)
           
            'Read AP Traffic secret uses Master Key & Session Hash
            bInfo = HKDF.CreateInfo("tls13 c ap traffic", SessionHash, 32)
            Call HKDF.Expand("SHA256", bMaster, bInfo, 32)
            bReadAP = HKDF.OutBuffer
            Call DispByte("tls13 c ap traffic", bReadAP)
            
            'The same info with modified context produces the Server Application secret
            bInfo(9) = 115 'tls13 s ap traffic
            Call HKDF.Expand("SHA256", bMaster, bInfo, 32)
            bWriteAP = HKDF.OutBuffer
            Call DispByte("tls13 s ap traffic", bWriteAP)
            
            'Exporter Master secret is derived from the Master key and context with unknown hash
            bInfo = HKDF.CreateInfo("tls13 exp master", SessionHash, 32)
            Call HKDF.Expand("SHA256", bMaster, bInfo, 32)
            Call DispByte("tls13 exp master", HKDF.OutBuffer)
            
            'Application Read Key uses Derived secret for Server Application and context
            'with zero length hash
            ReDim bTmp(0)
            bInfo = HKDF.CreateInfo("tls13 key", bTmp, 16)
            Call HKDF.Expand("SHA256", bWriteAP, bInfo, 16)
            If SvrFlg Then
                bWriteKey = HKDF.OutBuffer
                Call DispByte("AP Write Key", bWriteKey)
            Else
                bReadKey = HKDF.OutBuffer
                Call DispByte("AP Read Key", bReadKey)
            End If
            
            'Application Read IV uses Derived secret for Server Application and context
            'with zero length hash
            bInfo = HKDF.CreateInfo("tls13 iv", bTmp, 12)
            Call HKDF.Expand("SHA256", bWriteAP, bInfo, 12)
            If SvrFlg Then
                bWriteIV = HKDF.OutBuffer
                Call DispByte("AP Write IV", bWriteIV)
            Else
                bReadIV = HKDF.OutBuffer
                Call DispByte("AP Read IV", bReadIV)
            End If
            
            'Application Write Key uses Derived secret for Client Application and context
            'with zero length hash
            bInfo = HKDF.CreateInfo("tls13 key", bTmp, 16)
            Call HKDF.Expand("SHA256", bReadAP, bInfo, 16)
            If SvrFlg Then
                bReadKey = HKDF.OutBuffer
                Call DispByte("AP Read Key", bReadKey)
            Else
                bWriteKey = HKDF.OutBuffer
                Call DispByte("AP Write Key", bWriteKey)
            End If
            
            'Application Write IV uses Derived secret for Client Application  and context
            'with zero length hash
            bInfo = HKDF.CreateInfo("tls13 iv", bTmp, 12)
            Call HKDF.Expand("SHA256", bReadAP, bInfo, 12)
            If SvrFlg Then
                bReadIV = HKDF.OutBuffer
                Call DispByte("AP Read IV", bReadIV)
            Else
                bWriteIV = HKDF.OutBuffer
                Call DispByte("AP Write IV", bWriteIV)
            End If

        Case 3 'After Finished received
            'Receive Finished record & decrypt
'            SessionHash = UpdateHash("ServerFinished")
    
    End Select
End Function

Private Function UpdateHash(bRecord() As Byte) As Byte()
    Dim bSHA256Object() As Byte
    hSessionHash = HKDF.AddToHash("SHA256", bRecord, hSessionHash, lHash, bHashObject)
    bSHA256Object = bHashObject
    hCOPY_SHA256 = HKDF.CopyHash(hSessionHash, bSHA256Object)
    UpdateHash = HKDF.GetHash(hCOPY_SHA256, lHash)
End Function

Private Function UpdateHash2(RecType As String) As Byte()
    Const sClientHello = "010000c00303cb34ecb1e78163ba1c38" _
                        & "c6dacb196a6dffa21a8d9912ec18a2ef" _
                        & "6283024dece700000613011303130201" _
                        & "0000910000000b000900000673657276" _
                        & "6572ff01000100000a00140012001d00" _
                        & "17001800190100010101020103010400" _
                        & "230000003300260024001d002099381d" _
                        & "e560e4bd43d23d8e435a7dbafeb3c06e" _
                        & "51c13cae4d5413691e529aaf2c002b00" _
                        & "03020304000d0020001e040305030603" _
                        & "02030804080508060401050106010201" _
                        & "0402050206020202002d00020101001c" _
                        & "00024001"
    Const sSvrHello = "020000560303a6af06a4121860dc5e6e" _
                    & "60249cd34c95930c8ac5cb1434dac155" _
                    & "772ed3e2692800130100002e00330024" _
                    & "001d0020c9828876112095fe66762bdb" _
                    & "f7c672e156d6cc253b833df1dd69b1b0" _
                    & "4e751f0f002b00020304"
    Const sCert = "080000240022000a00140012001d00170018001901000101010201030104001c" _
                & "00024001000000000b0001b9000001b50001b0308201ac30820115a003020102" _
                & "020102300d06092a864886f70d01010b0500300e310c300a0603550403130372" _
                & "7361301e170d3136303733303031323335395a170d3236303733303031323335" _
                & "395a300e310c300a0603550403130372736130819f300d06092a864886f70d01" _
                & "0101050003818d0030818902818100b4bb498f8279303d980836399b36c6988c" _
                & "0c68de55e1bdb826d3901a2461eafd2de49a91d015abbc9a95137ace6c1af19e" _
                & "aa6af98c7ced43120998e187a80ee0ccb0524b1b018c3e0b63264d449a6d38e2" _
                & "2a5fda430846748030530ef0461c8ca9d9efbfae8ea6d1d03e2bd193eff0ab9a" _
                & "8002c47428a6d35a8d88d79f7f1e3f0203010001a31a301830090603551d1304" _
                & "023000300b0603551d0f0404030205a0300d06092a864886f70d01010b050003" _
                & "81810085aad2a0e5b9276b908c65f73a7267170618a54c5f8a7b337d2df7a594" _
                & "365417f2eae8f8a58c8f8172f9319cf36b7fd6c55b80f21a03015156726096fd" _
                & "335e5e67f2dbf102702e608ccae6bec1fc63a42a99be5c3eb7107c3c54e9b9eb" _
                & "2bd5203b1c3b84e0a8b2f759409ba3eac9d91d402dcc0cc8f8961229ac9187b4" _
                & "2b4de100000f000084080400805a747c5d88fa9bd2e55ab085a61015b7211f82" _
                & "4cd484145ab3ff52f1fda8477b0b7abc90db78e2d33a5c141a078653fa6bef78" _
                & "0c5ea248eeaaa785c4f394cab6d30bbe8d4859ee511f602957b15411ac027671" _
                & "459e46445c9ea58c181e818e95b8c3fb0bf3278409d3be152a3da5043e063dda" _
                & "65cdf5aea20d53dfacd42f74f3140000209b9b141d906337fbd2cbdce71df4de" _
                & "da4ab42c309572cb7fffee5454b78f0718"
    Const sFinish = "14000020a8ec436d677634ae525ac1fc" _
                    & "ebe11a039ec17694fac6e98527b642f2" _
                    & "edd5ce61"
    Dim bSHA256Object() As Byte
    Dim bClientHello() As Byte
    Dim bServerHello() As Byte
    Dim bCert() As Byte
    Dim bFinish() As Byte
    Select Case RecType
        Case "ClientHello"
            bClientHello = HexToByte(sClientHello)
            hSessionHash = 0 'Clear Hash
            hSessionHash = HKDF.AddToHash("SHA256", bClientHello, hSessionHash, lHash, bHashObject)
            bSHA256Object = bHashObject
            hCOPY_SHA256 = HKDF.CopyHash(hSessionHash, bSHA256Object)
            UpdateHash2 = HKDF.GetHash(hCOPY_SHA256, lHash)
            Call DispByte("Session Hash After ClientHello", UpdateHash2)
        Case "ServerHello"
            bServerHello = HexToByte(sSvrHello)
            hSessionHash = HKDF.AddToHash("SHA256", bServerHello, hSessionHash, lHash, bHashObject)
            bSHA256Object = bHashObject
            hCOPY_SHA256 = HKDF.CopyHash(hSessionHash, bSHA256Object)
            UpdateHash2 = HKDF.GetHash(hCOPY_SHA256, lHash)
            Call DispByte("Session Hash After ServerHello", UpdateHash2)
        Case "ServerCertificate"
            bCert = HexToByte(sCert)
            hSessionHash = HKDF.AddToHash("SHA256", bCert, hSessionHash, lHash, bHashObject)
            bSHA256Object = bHashObject
            hCOPY_SHA256 = HKDF.CopyHash(hSessionHash, bSHA256Object)
            UpdateHash2 = HKDF.GetHash(hCOPY_SHA256, lHash)
            Call DispByte("Session Hash After Server Certificate", UpdateHash2)
        Case "ServerFinished"
            bFinish = HexToByte(sFinish)
            hSessionHash = HKDF.AddToHash("SHA256", bFinish, hSessionHash, lHash, bHashObject)
            UpdateHash2 = HKDF.GetHash(hSessionHash, lHash)
            Call DispByte("Session Hash After Server Finished", UpdateHash2)
    End Select
End Function

Private Sub cmdConnect_Click()
     mClient.TCPConnect "localhost", 259
End Sub

Private Sub cmdFile_Click()
    Dim bSend() As Byte
    bSend = UniToByte("Get Kitty")
    Crypt.InBuffer = bSend
    Call Crypt.CryptData(KeyAlg, False)
    bSend = AddRecHeader(Crypt.OutBuffer)
    DispByte "Client Request", bSend
    mClient.bOutBuffer = bSend
    mClient.TCPSend
End Sub


Private Sub Form_Load()
    Set HKDF = New clsHKDF
    Set Crypt = New clsCrypt
    Set mClient = New SimpleSock
    mClient.EncrFlg = True
    ECK1 = HexToByte("45434B3120000000")
    KeyAlg = "AES"
    KeySize = 256
End Sub


Private Sub HKDF_Error(ByVal Number As Long, Description As String, ByVal Source As String)
    MsgBox "Error " & Hex$(Number) & ": " & Description & " in " & Source, vbExclamation
End Sub

Private Sub mClient_CloseSck()
    mClient.CloseSocket
    lblStatus.Caption = "Disconnected"
    Screen.MousePointer = Default
End Sub

Private Sub mClient_Connect()
    'Send Client Hello (Unencrypted)
    Dim bSend() As Byte
    lblStatus.Caption = "Connected"
    Screen.MousePointer = vbDefault
    hSessionHash = 0 'Reset Hash handles
    'Recover Internal ECC key BLOBs
    ReDim bPrivKeyBlob(0)
    ReDim bPubKeyBlob(0)
    Call HKDF.GetECCKey(StrPtr("ECDH_P256"), KeySize, bPubKeyBlob, bPrivKeyBlob)
    bSend = GetClientHello(bPubKeyBlob)
    SessionHash = UpdateHash(bSend)
    DispByte "Session Hash after Client Hello", SessionHash
    Crypt.MsgType = RT_HANDSHAKE
    bSend = AddRecHeader(bSend)
    mClient.bOutBuffer = bSend
    mClient.TCPSend
End Sub


Private Sub mClient_EncrDataArrival(ByVal bytesTotal As Long)
    Dim bData() As Byte
    'This routine is re-entrant, hence the next 3 variable must be static
    Static InBuff() As Byte
    Static Header() As Byte
    Static RecLen As Long
    Dim bTemp() As Byte
    Dim bSend() As Byte
    Dim sTemp As String
    Dim bAgreedSecret() As Byte
    Dim bPreSharedKey() As Byte
    Dim ErrCode As Long
    mClient.RecoverData
    bData = mClient.bInBuffer
    'DebugPrintByte "bData", bData
    Call AddByte(InBuff, bData) 'Add incoming data to buffer
GetNextRecord:
    If GetbSize(InBuff) < 5 Then Exit Sub 'If no record length yet then exit & wait
    If RecLen = 0 Then 'New record
        ReDim Header(4)
        CopyMemory Header(0), InBuff(0), 5 'Save header
        Call DeleteByte(InBuff, 5) ' Remove header from Record
        RecLen = Header(3) * 256 + Header(4)
        Select Case Header(0)
            Case RT_ALERT, RT_HANDSHAKE, RT_APPLICATION_DATA 'Update Msg Type
                Crypt.MsgType = Header(0)
            Case Else 'Ignore record
                InBuff = ""
                RecLen = 0
                GoTo Done
        End Select
    End If
    If GetbSize(InBuff) >= RecLen Then 'Complete record available
        ReDim bData(RecLen - 1) 'Resize buffer to Record Length
        CopyMemory bData(0), InBuff(0), RecLen 'Copy Record data to buffer
        Call DeleteByte(InBuff, RecLen) 'Delete Record data from InBuff
        Crypt.InBuffer = bData 'Load encryption buffer in case info is encrypted
    Else
        Exit Sub 'Wait for complete record
    End If
    If Header(0) = RT_ALERT Then 'Process Alert regardless of layer
        If Layer > 1 Then 'Encryption started
            Call Crypt.CryptData(KeyAlg, True) 'Use decrypted Data
            bTemp = Crypt.OutBuffer
        Else 'Encryption not started yet
            bTemp = Crypt.InBuffer
        End If
        ErrCode = bTemp(1)
        Select Case bTemp(0)
           Case 1
                If ErrCode = 0 Then 'Close Alert
                    Call mClient_CloseSck
                    GoTo Done
                Else
                    MsgBox "ALERT WARNING " & CStr(ErrCode)
                End If
            Case 2
                MsgBox "FATAL ALERT " & CStr(ErrCode)
                Call mClient_CloseSck
                If ErrCode = 70 Then
                    MsgBox "Server Version " & CStr(Header(1)) & "." & CStr(Header(2)) & vbCrLf _
                         & "Your Version " & VERSION_MAJOR & "." & VERSION_MINOR, vbExclamation
                 End If
                GoTo Done
            Case Else
                MsgBox "UNKOWN ERROR" & CStr(ErrCode)
        End Select
    End If
    'record complete - Process it
    Select Case Layer
        Case 0 'this layer processes the Server Hello
            bTemp = Crypt.InBuffer 'Use data as received
            If GetbSize(bTemp) > 35 Then 'Check for minimum length
                DispByte "SERVER HELLO", bTemp
                ReDim ECC_PUBLIC_KEY_EXT(RecLen + 7)
                CopyMemory ECC_PUBLIC_KEY_EXT(0), ECK1(0), 5
                CopyMemory ECC_PUBLIC_KEY_EXT(8), bTemp(0), RecLen
                'Recover Internal ECC private key BLOB
                ECC_PRIVATE_KEY_INT = bPrivKeyBlob
                'Get AgreedSecret
                'DebugPrintByte "Public Key", ECC_PUBLIC_KEY_EXT
                'DebugPrintByte "Private Key", ECC_PRIVATE_KEY_INT
                bAgreedSecret = HKDF.GetECCKey(StrPtr("ECDH_P256"), KeySize, ECC_PUBLIC_KEY_EXT, ECC_PRIVATE_KEY_INT)
'********** Temporary Code ************
            bAgreedSecret = HexToByte(sIKM)
'**************************************
                DispByte "Agreed Secret", bAgreedSecret
                'First stage keys are recovered here because we did not have
                'the Agreed Secret until now
                Call GetKeys(0, bAgreedSecret, bPreSharedKey) 'Update Keys
                SessionHash = UpdateHash(bTemp) 'Update Sessionhash  after Server Hello
                DispByte "Session Hash after Server Hello", SessionHash
                Call GetKeys(1, bAgreedSecret, bPreSharedKey) 'Update Keys
            End If
            Layer = Layer + 1
        Case 1 'this layer processes the Server Cert/Finished record (encrypted)
            Crypt.WriteKey = bWriteHSKey
            Crypt.WriteIV = bWriteHSIV
            Crypt.ReadKey = bReadHSKey
            Crypt.ReadIV = bReadHSIV
            Call Crypt.CryptData(KeyAlg, True) 'Use decrypted Data
            bTemp = Crypt.OutBuffer
            'Call DebugPrintByte("Server Finished", bTemp)
            SessionHash = UpdateHash(bTemp)
            DispByte "Session Hash after Server Finished", SessionHash
            Call GetKeys(2, bAgreedSecret, bPreSharedKey) 'Update Application Keys
            'Send Client Finished here
            bSend = bFinished 'GetClientFinish
            SessionHash = UpdateHash(bSend)
            DispByte "Session Hash after Client Finished", SessionHash
            Crypt.InBuffer = bSend
            Call Crypt.CryptData(KeyAlg, False)
            Crypt.MsgType = RT_APPLICATION_DATA
            bSend = AddRecHeader(Crypt.OutBuffer)
            'Call DebugPrintByte("Client Finish (encrypted)", bSend)
            mClient.bOutBuffer = bSend
            mClient.TCPSend
            Layer = Layer + 1
            lblStatus.Caption = lblStatus.Caption & ": Handshake Complete!"
            Crypt.WriteKey = bWriteKey 'Set Application keys
            Crypt.WriteIV = bWriteIV 'Keys for Client are opposite to Server
            Crypt.ReadKey = bReadKey
            Crypt.ReadIV = bReadIV
        Case Else 'Application data starts here
            If Header(0) = &H17 Then
                Call Crypt.CryptData(KeyAlg, True) 'Decrypt
                SessionHash = UpdateHash(Crypt.OutBuffer)
                sTemp = Crypt.OutBuffer
            Else 'Ignore anything else per RFC2246
                sTemp = "Invalid Data"
            End If
            txtHex.Text = txtHex.Text & sTemp & vbCrLf
            txtHex.SelStart = Len(txtHex.Text)
End Select
Done:
    RecLen = 0
    ReDim Header(0)
    If GetbSize(InBuff) > 0 Then GoTo GetNextRecord
End Sub

Private Sub mClient_Error(ByVal Number As Long, Description As String, ByVal Source As String)
    lblStatus.Caption = "ERROR " & Number & ": " & Description
    Screen.MousePointer = Default
    Call mClient_CloseSck
End Sub


